package com.malk.xiding.controller;

import com.malk.server.common.McR;
import com.malk.server.fxiaoke.FXKConf;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Attendance;
import com.malk.service.dingtalk.DDClient_Contacts;
import com.malk.service.dingtalk.DDService;
import com.malk.service.fxiaoke.FXKClient;
import com.malk.xiding.repository.dao.XdDdApproveRecordDao2;
import com.malk.xiding.repository.dao.XdDdFxkRelationDao;
import com.malk.xiding.service.XDService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 错误抛出与拦截详见CatchException
 */
@Slf4j
@RestController
@RequestMapping("/xiding")
public class XDController {

    @Autowired
    private XDService xdService;

    @Autowired
    private DDClient_Attendance ddClient_attendance;

    @Autowired
    private DDClient ddClient;

    @Autowired
    private DDClient_Contacts ddClient_contacts;

    @Autowired
    private XdDdApproveRecordDao2 approveRecordDao2;

    @Autowired
    private FXKClient fxkClient;

    @Autowired
    private FXKConf fxkConf;

    @Autowired
    private XdDdFxkRelationDao relationDao;

    @PostMapping("test3")
    McR test3(@RequestParam String name) {
//        Date sTime = UtilDateTime.parseDateTime("2023-07-01" + " 00:00:00");
//        Date eTime = UtilDateTime.parseDateTime("2023-05-31" + " 23:59:59");

//        List<Map> records = fxkClient.getAttendance_All(fxkClient.getAccessToken(), fxkConf.getCorpId(), sTime.getTime(), eTime.getTime(), Arrays.asList(relationDao.findByName(name).getIdFxxk()));
//        log.info("xxxx, {}", records.size());
//
//        Date tTime = UtilDateTime.parseDateTime("2023-05-04" + " 04:11:00");
//
//        // 时区测试 @Temporal & @JsonFormat
//        Date check = UtilDateTime.parseDateTime(UtilDateTime.formatDate(new Date(tTime.getTime() - (tTime.getHours() + 1) * 60 * 60 * 1000)) + " 18:00:00");
//        log.error("xxxx, {}", JSON.parseObject(JSON.toJSONString(records.get(0)), XdFxkDdAttendancePo.class));
//
//        log.info("xxxx, {}, {}", check, UtilDateTime.formatDateTime(new Date(tTime.getTime() - (tTime.getHours() + 1) * 60 * 60 * 1000)));
//        return McR.success(JSON.parseArray(JSON.toJSONString(records), XdFxkDdAttendancePo.class));
//        return McR.success(JSON.parseObject(JSON.toJSONString(records.get(0)), XdFxkDdAttendancePo.class));

//        return McR.success(approveRecordDao2.findAllByEndTimeAfterAndTypeAndMarketing(sTime, "出差", true, PageRequest.of(0, Integer.MAX_VALUE)));
        return McR.success();
    }

    @PostMapping("test1")
    McR test1() {
//        Date eTime = UtilDateTime.parseDateTime(UtilDateTime.formatDate(new Date()) + " 23:59:59");
//        Date sTime = UtilDateTime.parseDateTime(UtilDateTime.formatDate(new Date()) + " 11:00:00");
//
//        String Time = UtilDateTime.formatLocalDate(UtilDateTime.convertToLocalDateTimeFromDate(sTime).plusDays(1).toLocalDate()) + " 05:00:00";
//
//        log.info("xxxx, {}, {}", sTime, Time);
//        ddClient_attendance.listAttendanceRecord(ddClient.getAccessToken(), Arrays.asList("01184453430538751536"), "2023-07-17 00:00:00", "2023-07-17 23:59:59");

//        return McR.success(ddClient_attendance.uploadAttendanceRecord(ddClient.getAccessToken(), "1111", "纷享销客同步", "纷享销客同步", null, new Date().getTime()));
//        return McR.success(approveRecordDao2.findAllByEndTimeAfter(UtilDateTime.parseDateTime("2023-05-18 00:00:00"), PageRequest.of(0, 50)));
        return McR.success();
    }

    @PostMapping("test11")
    McR test() {
//        long startTime = UtilDateTime.parseDateTime("2023-08-27" + " 00:00:00").getTime();
//        long endTime = UtilDateTime.parseDateTime("2023-08-31" + " 23:59:59").getTime();
////        xdService.syncApprove(startTime, endTime, XDConf.TMP_CODE_CC, "出差");
//        xdService.syncApprove(startTime, endTime, XDConf.TMP_CODE_WC, "外出");
        return McR.success();
    }

    @PostMapping("test2")
    McR test2() {
//        Date sTime = UtilDateTime.parseDateTime("2023-08-04" + " 00:00:00");
//        Date eTime = UtilDateTime.parseDateTime("2023-08-10" + " 23:59:59");
//        xdService.syncAttendance(0, sTime, eTime);
//        xdService.syncAttendanceForCC(0, sTime, eTime);
        return McR.success();
    }

    @PostMapping("test5")
    McR test5() {
//        ddClient_attendance.uploadAttendanceRecord(ddClient.getAccessToken(), "01184453430538751536", "纷享销客同步", "纷享销客同步", null, 1689555600000L);
        return McR.success();
    }

    @Autowired
    private DDService ddService;

    @Autowired
    private XdDdApproveRecordDao2 xdDdApproveRecordDao2;

    @PostMapping("test6")
    McR test6() {

//        List<Number> deptIdList = (List<Number>) ddClient_contacts.getUserInfoByMobile(ddClient.getAccessToken(), "15399923686").get("dept_id_list");
//        return McR.success(ddService.matchDepartment(ddClient.getAccessToken(), "01513053652926638706", Arrays.asList(37263540L)));

//        Date sTime = UtilDateTime.parseDateTime("2023-07-01" + " 00:00:00");
//        Date eTime = UtilDateTime.parseDateTime("2023-07-16" + " 23:59:59");
//
//        xdDdApproveRecordDao2.findAllByEndTimeAfterAndTypeAndMarketing(sTime, "出差", false, PageRequest.of(0, Integer.MAX_VALUE)).forEach(po -> {
//            try {
//                boolean isMarketing = ddService.matchDepartment(ddClient.getAccessToken(), po.getUserId(), Arrays.asList(37263540L));
//                po.setMarketing(isMarketing);
//                xdDdApproveRecordDao2.save(po);
//            } catch (McException e) {
//
//            }
//        });
//        return McR.success(ddService.matchDepartment(ddClient.getAccessToken(), "16859286440945113", Arrays.asList(37263540L)));
        return McR.success();
    }
}
